Draft Upgrade
|
Menu location |
---|
Modification → Upgrade Modify → Upgrade |
Workbenches |
Draft, BIM |
Default shortcut |
U P |
Introduced in version |
- |
See also |
Draft Downgrade |
Description
The Draft Upgrade command upgrades selected objects. The result depends on the number of selected objects and their type. The command can for example fuse elements and create faces. It is worth trying to upgrade a selection several times to see if a better result can be obtained. See the example in the image. Note that not all objects can be upgraded. This command is the counterpart of the Draft Downgrade command.
An open non-editable wire is upgraded to a closed wire, and then to a face. A closed non-editable square wire is also upgraded to a face. The two faces are then upgraded to create a compound, which is finally upgraded to a single editable Draft Wire.
Usage
- Optionally select one or more objects.
- There are several ways to invoke the command:
- If you have not yet selected an object: select an object in the 3D view.
Notes
- Draft Lines and Draft Wires can be joined with this command, but also with the Draft Join command or the Draft Wire command.
Scripting
See also: Autogenerated API documentation and FreeCAD Scripting Basics.
To upgrade objects use the upgrade
method of the Draft module.
upgrade_list = upgrade(objects, delete=False, force=None)
objects
contains the objects to be upgraded. It is either a single object or a list of objects.- If
delete
isTrue
the source objects are deleted. force
forces a certain way of upgrading by calling a specific internal function. It can be:"makeCompound"
,"closeGroupWires"
,"makeSolid"
,"closeWire"
,"turnToParts"
,"makeFusion"
,"makeShell"
,"makeFaces"
,"draftify"
,"joinFaces"
,"makeSketchFace"
,"makeWires"
or"turnToLine"
.upgrade_list
is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. Ifdelete
isTrue
the second list is empty.
Example:
import FreeCAD as App
import Draft
doc = App.newDocument()
circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()
add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=False)
line1 = Draft.make_line(App.Vector(2000, 0, 0), App.Vector(2500, 1500, 0))
line2 = Draft.make_line(App.Vector(2500, 1500, 0), App.Vector(3000, -1000, 0))
doc.recompute()
add_list2, delete_list2 = Draft.upgrade([line1, line2], delete=False)
simple_wire = add_list2[0]
add_list3, delete_list3 = Draft.upgrade(simple_wire, delete=False)
closed_wire = add_list3[0]
add_list4, delete_list4 = Draft.upgrade(closed_wire, delete=False)
face = add_list4[0]
add_list5, delete_list5 = Draft.upgrade(face, delete=False)
doc.recompute()
- Drafting: Line, Polyline, Fillet, Arc, Arc by 3 points, Circle, Ellipse, Rectangle, Polygon, B-spline, Cubic Bézier curve, Bézier curve, Point, Facebinder, ShapeString, Hatch
- Annotation: Text, Dimension, Label, Annotation styles, Annotation scale
- Modification: Move, Rotate, Scale, Mirror, Offset, Trimex, Stretch, Clone, Array, Polar array, Circular array, Path array, Path link array, Point array, Point link array, Edit, Subelement highlight, Join, Split, Upgrade, Downgrade, Wire to B-spline, Draft to sketch, Set slope, Flip dimension, Shape 2D view
- Draft Tray: Select plane, Set style, Toggle construction mode, AutoGroup
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid
- Miscellaneous: Apply current style, Layer, Manage layers, Add a new named group, Move to group, Select group, Add to construction group, Toggle normal/wireframe display, Create working plane proxy, Heal, Show snap toolbar
- Additional: Constraining, Pattern, Preferences, Import Export Preferences, DXF/DWG, SVG, OCA, DAT
- Context menu:
- Layer container: Merge layer duplicates, Add new layer
- Layer: Activate this layer, Select layer contents
- Text: Open hyperlinks
- Wire: Flatten
- Working plane proxy: Write camera position, Write objects state

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub